//
//  CalControls.java
//  tester
//
//  Created by Mike Willegal on Wed May 11 2005.
//  Copyright (c) 2005 Mike Willegal
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//

import java.awt.*;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;


class CalControls extends JPanel implements FocusListener, ActionListener {

tester applet;
JLabel Title;
JLabel[] speeds;
JCheckBox[] speedschk;
JFormattedTextField recorded_exposure_left[];
JFormattedTextField recorded_exposure_right[];
JFormattedTextField recorded_speed_1st[];
JFormattedTextField recorded_speed_2nd[];
NumberFormat numberFormat1;
private NumberFormat numberFormat2;

JButton step_button, cal_button;
JLabel step_description;

final int numberofspeeds = 6;

JPanel CalData, StepData;

final String speed1 = "slow speed";
final String speed2 = "reversed";
final String speed3 = "medium speed";
final String speed4 = "reversed";
final String speed5 = "high speed";
final String speed6 = "reversed";

final String [] speed_names = {
	speed1,
        speed2,
	speed3,
	speed4,
	speed5,
	speed6
};

boolean capture = false;
boolean autospeed = true;

float []	rec_exposure_left = new float [numberofspeeds];
float []	rec_exposure_right = new float [numberofspeeds];
float []	rec_speed_1st = new float [numberofspeeds];
float []	rec_speed_2nd = new float [numberofspeeds];

int currentstep;

final String step1 = "Step1: cycle shutter at slow speed";
final String step2 = "Step2: cycle shutter at medium speed";
final String step3 = "Step3: cycle shutter at high speed";
final String step4 = "Step4: reverse the position of the sensor";
final String step5 = "Step5: cycle shutter at high speed";
final String step6 = "Step6: cycle shutter ato medium speed";
final String step7 = "Step7: cycle shutter at slowest speed";
final String step8 = "Step8: type difference from actual into Cal +/-";

final int numberofsteps = 8;
JRadioButton[] steps;
final int defaultstep = 0;

JFormattedTextField cal_value;

final String [] step_names = {
	step1,
        step2,
	step3,
	step4,
	step5,
	step6,
        step7,
        step8,
};

float effect = 0;
float adjustment = 0;
boolean calibrate_enable = false;

CalControls (tester parent)
{
	int i;
	applet = parent;
        
        setnumberFormat1 ();
        numberFormat2 = NumberFormat.getNumberInstance();
        numberFormat2.setMaximumFractionDigits(2);

        setLayout(new GridLayout(0,1));
        CalData = new JPanel();
        
	CalData.setLayout(new GridLayout(0,5));


        Title = new JLabel("Samples");
        CalData.add (Title);
	Title = new JLabel("Exposure Left");
	CalData.add (Title);
	Title = new JLabel("Exposure Right");
	CalData.add (Title);
	Title = new JLabel("Speed 1st");
	CalData.add (Title);
	Title = new JLabel("Speed 2nd");
	CalData.add (Title);
	
	
	recorded_exposure_left = new JFormattedTextField [numberofspeeds];
	recorded_exposure_right = new JFormattedTextField [numberofspeeds];
	recorded_speed_1st = new JFormattedTextField [numberofspeeds];
	recorded_speed_2nd = new JFormattedTextField [numberofspeeds];
        speeds = new JLabel [numberofspeeds];
        speedschk = new JCheckBox [numberofspeeds];


	for (i = 0; i<numberofspeeds; i++) {
                if ((i % 2) == 0) {
                    speedschk[i] = new JCheckBox(speed_names[i]);
                } else {
                   speeds[i] = new JLabel(speed_names[i]);
                }

		recorded_exposure_left[i] = new JFormattedTextField(numberFormat1);
                recorded_exposure_left[i].setHorizontalAlignment(JTextField.CENTER);
                recorded_exposure_left[i].addActionListener( this);
                recorded_exposure_left[i].addFocusListener (this);
                                            
		recorded_exposure_right[i] = new JFormattedTextField(numberFormat1);
                recorded_exposure_right[i].setHorizontalAlignment(JTextField.CENTER);
                recorded_exposure_right[i].addActionListener( this);
                recorded_exposure_right[i].addFocusListener (this);
                
		recorded_speed_1st[i] = new JFormattedTextField(numberFormat2);
                recorded_speed_1st[i].setHorizontalAlignment(JTextField.CENTER);
                recorded_speed_1st[i].addActionListener( this);
                recorded_speed_1st[i].addFocusListener (this);
               
		recorded_speed_2nd[i] = new JFormattedTextField(numberFormat2);
                recorded_speed_2nd[i].setHorizontalAlignment(JTextField.CENTER);
                recorded_speed_2nd[i].addActionListener(this);
                recorded_speed_2nd[i].addFocusListener (this);
	}			

	for (i = 0; i<numberofspeeds; i++) {
                if ((i % 2) == 0) {
                    CalData.add (speedschk[i]);
                } else {
                   CalData.add (speeds[i]);
                }

		CalData.add(recorded_exposure_left[i]);
		recorded_exposure_left[i].setVisible(true);
		
		CalData.add(recorded_exposure_right[i]);
		recorded_exposure_right[i].setVisible(true);

		CalData.add(recorded_speed_1st[i]);
		recorded_speed_1st[i].setVisible(true);

		CalData.add(recorded_speed_2nd[i]);
		recorded_speed_2nd[i].setVisible(true);
				
		
	}
        
        JLabel cal_title = new JLabel("Calibrate +/- uSecs");
	cal_value = new JFormattedTextField(String.valueOf (applet.cal_adjust));
 
        cal_value.addActionListener( this);
        cal_value.addFocusListener (this);

        CalData.add(cal_title);
        CalData.add(cal_value);

    
        StepData = new JPanel();
	StepData.setLayout(new GridLayout(0,2));

       	ButtonGroup stepgroup = new ButtonGroup();
        steps = new JRadioButton [numberofsteps];

	for (i = 0; i<numberofsteps; i++) {
                steps[i] = new JRadioButton(step_names[i]);
                steps[i].setActionCommand(step_names[i]);
		steps[i].addActionListener(this);
                stepgroup.add(steps[i]);
                StepData.add(steps[i]);
        }
	
        step_button = new JButton("Next Step");
        step_button.setActionCommand("Next Step");
        step_button.addActionListener(this);
	StepData.add(step_button);
        
        cal_button = new JButton("Calibrate");
        cal_button.setActionCommand("Calibrate");
        cal_button.addActionListener(this);
	StepData.add(cal_button);

        steps[defaultstep].setSelected(true);

        add(StepData);
        add(CalData);
        
	cal_value.addActionListener(this);
	cal_value.addFocusListener (this);
        
        populate_data();

        default_settings();
	validate();
	applet.validate();
}

void setnumberFormat1 ()
{
        numberFormat1 = NumberFormat.getNumberInstance();
        numberFormat1.setMaximumFractionDigits(2);

}

public void newdata (byte error, boolean in_autospeed, float exposure_left, float exposure_right, float speed_1st, float speed_2nd)
{
	int speed;
	String str;
        
        speed = currentstep;

        switch (currentstep) {
            case 0:
            case 1:
            case 2:
                speed = currentstep*2;
                break;
            case 4:
                speed =5;
                break;
            case 5:
                speed =3;
                break;
            case 6:
                speed =1;
                break;
            case 3:
            case 7:
            default:
                return; 
        }
	if (error == 0) {
            rec_exposure_left[speed] = exposure_left;
            rec_exposure_right[speed] = exposure_right;
            rec_speed_1st[speed] = speed_1st;
            rec_speed_2nd[speed] = speed_2nd;
            newdata_row(speed);
            if (in_autospeed && autospeed) {
                set_next_step ();
                if (currentstep == 3)
                    set_next_step();
            }
        }
        
}

public void newdata_row (int speed)
{
    if (calibrate_enable) {
        if ((speed % 2) == 0) {
            recorded_exposure_left[speed].setValue(new Float(rec_exposure_left[speed]+effect+adjustment));
            recorded_exposure_right[speed].setValue(new Float(rec_exposure_right[speed]-effect+adjustment));
            recorded_speed_1st[speed].setValue(new Float(rec_speed_1st[speed]+effect));
            recorded_speed_2nd[speed].setValue(new Float(rec_speed_2nd[speed]-effect));
        } else {
            recorded_exposure_left[speed].setValue(new Float(effect));
            recorded_exposure_right[speed].setValue(new Float(-effect));
            recorded_speed_1st[speed].setValue(new Float(effect));
            recorded_speed_2nd[speed].setValue(new Float(-effect));
        }
    } else {
	recorded_exposure_left[speed].setValue(new Float(rec_exposure_left[speed]));
	recorded_exposure_right[speed].setValue(new Float(rec_exposure_right[speed]));
	recorded_speed_1st[speed].setValue(new Float(rec_speed_1st[speed]));
	recorded_speed_2nd[speed].setValue(new Float(rec_speed_2nd[speed]));
    }
}

private void populate_data ()
{
    int i;
            for (i = 0; i<numberofspeeds; i++) {
                newdata_row(i);
            }

}

public void focusGained(FocusEvent e) {}
public void focusLost(FocusEvent e) {
       Object source = e.getSource();

            if (source.equals(cal_value)){
                    try {
                           cal_value.commitEdit();
                        }
                        catch (ParseException pe) {
                        }
                        adjustment = Float.parseFloat(String.valueOf(cal_value.getValue()));
            } else  {
                        check_new_input (e.getSource());
            }
}



public void actionPerformed(ActionEvent e) {

	int number, i;
        String cmd;
        Float f;
        Object source = e.getSource();
        cmd = e.getActionCommand();
        
            for (i = 0; i<numberofsteps; i++) {
                    if (cmd.equals (step_names[i])) {
                        steps[i].setSelected(true);
                        setstep(i);
                        System.out.println("check box:"+step_names[i]);
                        currentstep = i;
                    }
            }
            if (cmd.equals ("Next Step")) {
               set_next_step();
            } else if (cmd.equals ("Calibrate")) {
               calibrate();
            } else if (source.equals(cal_value)){
                        try {
                           cal_value.commitEdit();
                        }
                        catch (ParseException pe) {
                        }
                        adjustment = Float.parseFloat(String.valueOf(cal_value.getValue())); 
            } else {
                        check_new_input (source);
            }
}

private void check_new_input ( Object source)
{
        int number, i;
       float f;

            for (i = 0; i<numberofspeeds; i++) {
               
                if (source.equals(recorded_exposure_left[i])){
                        try {
                            recorded_exposure_left[i].commitEdit();
                        }
                        catch (ParseException pe) {
                        }
                        rec_exposure_left[i]=f = Float.parseFloat(String.valueOf(recorded_exposure_left[i].getValue()));
                        break;
                } else if (source.equals(recorded_exposure_right[i])){
                        try {
                            recorded_exposure_right[i].commitEdit();
                        }
                        catch (ParseException pe) {
                        }
                        rec_exposure_right[i]=f=Float.parseFloat(String.valueOf(recorded_exposure_right[i].getValue()));
                        break;
                } else if (source.equals(recorded_speed_1st[i])){
                        try {
                            recorded_speed_1st[i].commitEdit();
                        }
                        catch (ParseException pe) {
                        }
                        rec_speed_1st[i]=f =Float.parseFloat(String.valueOf(recorded_speed_1st[i].getValue()));
                        break;
                } else if (source.equals(recorded_speed_2nd[i])){
                        try {
                            recorded_speed_2nd[i].commitEdit();
                        }
                        catch (ParseException pe) {
                        }
                        rec_speed_2nd[i]=f=Float.parseFloat(String.valueOf(recorded_speed_2nd[i].getValue()));
                        break;
                } 
        
            }		

}

void default_settings ()
{
	int i;
	
	for (i=0; i<numberofspeeds; i++) {
		rec_speed_1st[i] = 0;
		rec_speed_2nd[i] = 0;
		rec_exposure_left[i] = 0;
		rec_exposure_right[i] = 0;
                newdata_row (i);
	}
	currentstep = defaultstep;
        autospeed = true;
	
}

int set_next_step ()
{
        int i;
        i = currentstep;
	if (i<numberofsteps-1) {
		i++;
                setstep (i);
        }
	return i;
}


public void setstep (int step) {
	currentstep = step;
        steps[step].setSelected(true);
        System.out.println("check box:"+step_names[currentstep]+"step:"+currentstep);
}

public void calibrate () {
    int i, count;
    float eff1, eff2;
    
    eff1 = 0;
    eff2 = 0;
    effect = 0;
    count = 0;
    for (i=0; i<numberofspeeds; i=i+2) {
        if( !speedschk[i].isSelected())
                continue;
        count++;
        eff1 = (rec_exposure_left[i+1]  - rec_exposure_left[i]) + eff1;
        eff2 = (rec_exposure_right[i]  - rec_exposure_right[i+1]) + eff2;
    }
    if (count != 0) {
        eff1 = eff1/(count*2);
        eff2 = eff2/(count*2);
        System.out.println("effect1:" + eff1  +"   effect2:"+eff2);
        effect = (eff1 + eff2)/2;
        adjustment = Float.parseFloat(String.valueOf(cal_value.getValue()));
        System.out.println("final effect:" + effect  + "adjustment:"+adjustment);
        applet.newcal(adjustment, effect);
    }
    populate_data ();
}

public void autoSpeed (boolean value) {
	autospeed = value;
}


public void calEnable (boolean cal)
{
    calibrate_enable = cal;
    populate_data ();
}



}
