//  tester
//
//  Copyright (c) 2005 Mike Willegal
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

class ConfigButtons extends JPanel implements ActionListener{
tester applet;
JTextField status;
JRadioButton run_button, stop_button;
JRadioButton auto_speed, man_speed;
JRadioButton calibrate_en, calibrate_dis;
JFileChooser chooser;


ConfigButtons (tester parent)
{
	
	Font f = new Font("TimesRoman", Font.PLAIN,12);	
	setFont(f);
	applet = parent;
         
	this.setLayout(new GridLayout(0,4));

//	setBackground(Color.green);

	run_button = new JRadioButton("Monitoring Tester");
        run_button.setActionCommand("start");
	add(run_button);
	run_button.addActionListener(this);

	auto_speed = new JRadioButton("Automatic Speed Select");
        auto_speed.setActionCommand("auto");
        auto_speed.setSelected(true);
	add(auto_speed);
        auto_speed.addActionListener(this);

 	calibrate_en = new JRadioButton("Calibrate Enable");
        calibrate_en.setActionCommand("cal_en");
	add(calibrate_en);
        calibrate_en.addActionListener(this);
        
        status = new JTextField("OK",30);
	status.setEditable(false);
	add(status);

	stop_button = new JRadioButton("Not Monitoring Tester");
        stop_button.setActionCommand("stop");
        stop_button.setSelected(true);
	add(stop_button);
	stop_button.addActionListener(this);
        
	man_speed = new JRadioButton("Manual Speed Select");
        man_speed.setActionCommand("manual");
	add(man_speed);
        man_speed.addActionListener(this);

  	calibrate_dis = new JRadioButton("Calibrate Disable");
        calibrate_dis.setActionCommand("cal_dis");
        calibrate_dis.setSelected(true);
	add(calibrate_dis);
        calibrate_dis.addActionListener(this);
 
      
        ButtonGroup start_stop_group = new ButtonGroup();
        start_stop_group.add(run_button);
        start_stop_group.add(stop_button);

        ButtonGroup auto_man_group = new ButtonGroup();
        auto_man_group.add(auto_speed);
        auto_man_group.add(man_speed);
		
        ButtonGroup en_dis_calibrate = new ButtonGroup();
        en_dis_calibrate.add(calibrate_en);
        en_dis_calibrate.add(calibrate_dis);


}



public synchronized void actionPerformed (ActionEvent evt) {
        String ac;
           	ac = evt.getActionCommand();
    
		if (ac.equals("stop")) {
                                applet.monitor.halt();
                } else if (ac.equals("start")) {
                                applet.monitor.go();
                } else if (ac.equals("manual")) {
                                applet.autoSpeed(false);
                } else if (ac.equals("auto")) {
                                applet.autoSpeed(true);
                } else if (ac.equals("cal_en")) {
                                applet.calEnable(true);
                } else if (ac.equals("cal_dis")) {
                                applet.calEnable(false);
                }
}
}