//  tester
//
//  Copyright (c) 2005 Mike Willegal
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import java.awt.*;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

class ConfigControls extends JPanel implements FocusListener, ActionListener {

tester applet;
JLabel Title;
JRadioButton[] speeds;
JFormattedTextField recorded_exposure_left[];
JFormattedTextField recorded_exposure_right[];
JFormattedTextField recorded_speed_1st[];
JFormattedTextField recorded_speed_2nd[];
NumberFormat numberFormat1;
private NumberFormat numberFormat2;


final int numberofspeeds = 11;

boolean capture = false;
float []	rec_exposure_left = new float [numberofspeeds];
float []	rec_exposure_right = new float [numberofspeeds];
float []	rec_speed_1st = new float [numberofspeeds];
float []	rec_speed_2nd = new float [numberofspeeds];

int currentspeed;
boolean autospeed = true;
boolean calibrate = false;
float        adjustment = 0;
float        effect = 0;

final int defaultspeed = 6;
//final String sp8overone = "8 seconds";
//final String sp4overone = "4 seconds";
//final String sp2overone = "2 seconds";
final String sponeoverone = "1 sec (1000 MS)";
final String sponeover2 = "1/2 sec (500 MS)";
final String sponeover4 = "1/4 sec (250 MS)";
final String sponeover8 = "1/8 sec (125 MS)";
final String sponeover15 = "1/15 sec (67 MS)";
final String sponeover30 = "1/30 sec (33 MS)";
final String sponeover60 = "1/60 sec (16 MS)";
final String sponeover125 = "1/125 sec (8 MS)";
final String sponeover250 = "1/250 sec (4 MS)";
final String sponeover500 = "1/500 sec (2 MS)";
final String sponeover1000 = "1/1000 sec (1 MS)";
//final String sponeover2000 = "1/2000 second";
//final String sponeover4000 = "1/4000 second";
//final String sponeover8000 = "1/8000 second";


final String [] speed_names = {
//	sp8overone,
//	sp4overone,
//	sp2overone,
	sponeoverone,
	sponeover2,
	sponeover4,
	sponeover8,
	sponeover15,
	sponeover30,
	sponeover60,
	sponeover125,
	sponeover250,
	sponeover500,
	sponeover1000,
//	sponeover2000,
//	sponeover4000,
//	sponeover8000
};


final float [] speed_values = {
//	8000,
//	4000,
//	2000,
	1000,
	500,
	250,
	125,
	67.5f,
	33.3f,
	16.7f,
	8,
	4,
	2,
	1,
//	.5f,
//	.2f,
//	.1f
};




ConfigControls (tester parent)
{
	int i;
	applet = parent;
        
        setnumberFormat1 ();
        numberFormat2 = NumberFormat.getNumberInstance();
        numberFormat2.setMaximumFractionDigits(2);
        
	setLayout(new GridLayout(0,5));

        Title = new JLabel("Speed Select");
        add (Title);
	Title = new JLabel("Exposure Left");
	add (Title);
	Title = new JLabel("Exposure Right");
	add (Title);
	Title = new JLabel("Speed 1st");
	add (Title);
	Title = new JLabel("Speed 2nd");
	add (Title);
	
	
	recorded_exposure_left = new JFormattedTextField [numberofspeeds];
	recorded_exposure_right = new JFormattedTextField [numberofspeeds];
	recorded_speed_1st = new JFormattedTextField [numberofspeeds];
	recorded_speed_2nd = new JFormattedTextField [numberofspeeds];
        speeds = new JRadioButton [numberofspeeds];
	ButtonGroup group = new ButtonGroup();


	for (i = 0; i<numberofspeeds; i++) {
                speeds[i] = new JRadioButton(speed_names[i]);
                speeds[i].setActionCommand(speed_names[i]);
		speeds[i].addActionListener(this);
                group.add(speeds[i]);
 

		recorded_exposure_left[i] = new JFormattedTextField(numberFormat1);
                recorded_exposure_left[i].setHorizontalAlignment(JTextField.CENTER);
                recorded_exposure_left[i].setValue(new Float(rec_exposure_left[i]));
                recorded_exposure_left[i].addActionListener( this);
                recorded_exposure_left[i].addFocusListener (this);
                
		recorded_exposure_right[i] = new JFormattedTextField(numberFormat1);
                recorded_exposure_right[i].setHorizontalAlignment(JTextField.CENTER);
                recorded_exposure_right[i].setValue(new Float(rec_exposure_right[i]));
                recorded_exposure_right[i].addActionListener( this);
                recorded_exposure_right[i].addFocusListener (this);
                
		recorded_speed_1st[i] = new JFormattedTextField(numberFormat2);
                recorded_speed_1st[i].setHorizontalAlignment(JTextField.CENTER);
                recorded_speed_1st[i].setValue(new Float(rec_speed_1st[i]));
                recorded_speed_1st[i].addActionListener( this);
                recorded_speed_1st[i].addFocusListener (this);
                
		recorded_speed_2nd[i] = new JFormattedTextField(numberFormat2);
                recorded_speed_2nd[i].setHorizontalAlignment(JTextField.CENTER);
                recorded_speed_2nd[i].setValue(new Float(rec_speed_2nd[i]));
                recorded_speed_2nd[i].addActionListener(this);
                recorded_speed_2nd[i].addFocusListener (this);
	}			
	newControls ();
        default_settings();
}

void setnumberFormat1 ()
{
        numberFormat1 = NumberFormat.getNumberInstance();
        numberFormat1.setMaximumFractionDigits(2);

}

public void newdata (byte error, boolean in_autospeed, float exposure_left, float exposure_right, float speed_1st, float speed_2nd)
{
	int i, speed;
	String str;
        
        if (in_autospeed && autospeed)
            speed = find_closest_speed((exposure_left+exposure_right)/2);
        else
            speed = currentspeed;

	if (error == 0) {
            rec_exposure_left[speed] = exposure_left;
            rec_exposure_right[speed] = exposure_right;
            rec_speed_1st[speed] = speed_1st;
            rec_speed_2nd[speed] = speed_2nd;
            newdata_row(speed);
        }
        
}

public void newdata_row (int speed, float exposure_left, float exposure_right, float speed_1st, float speed_2nd)
{
            rec_exposure_left[speed] = exposure_left;
            rec_exposure_right[speed] = exposure_right;
            rec_speed_1st[speed] = speed_1st;
            rec_speed_2nd[speed] = speed_2nd;
            newdata_row(speed);
}

public void newdata_row (int speed)
{
    if (calibrate) {
            recorded_exposure_left[speed].setValue(new Float(rec_exposure_left[speed]+effect+adjustment));
            recorded_exposure_right[speed].setValue(new Float(rec_exposure_right[speed]-effect+adjustment));
            recorded_speed_1st[speed].setValue(new Float(rec_speed_1st[speed]+effect));
            recorded_speed_2nd[speed].setValue(new Float(rec_speed_2nd[speed]-effect));
    } else {
	recorded_exposure_left[speed].setValue(new Float(rec_exposure_left[speed]));	
	recorded_exposure_right[speed].setValue(new Float(rec_exposure_right[speed]));
	recorded_speed_1st[speed].setValue(new Float(rec_speed_1st[speed]));
	recorded_speed_2nd[speed].setValue(new Float(rec_speed_2nd[speed]));
    }
}

private void populate_data ()
{
    int i;
            for (i = 0; i<numberofspeeds; i++) {
                newdata_row(i);
            }

}
public void focusGained(FocusEvent e) {}
public void focusLost(FocusEvent e) {
                check_new_input (e.getSource());
}



public void actionPerformed(ActionEvent e) {
	JTextField source;
	String txt;
	int number, i;
        String cmd;

            cmd = e.getActionCommand();
            for (i = 0; i<numberofspeeds; i++) {
                    if (cmd.equals (speed_names[i])) {
                        speeds[i].setSelected(true);
                        setspeed(i);
                        System.out.println("check box"+speed_names[i]);
                    }
            }			

            check_new_input (e.getSource());
}

private void check_new_input ( Object source)
{
        int number, i;
       float f;

            for (i = 0; i<numberofspeeds; i++) {
               
                if (source.equals(recorded_exposure_left[i])){
                        try {
                            recorded_exposure_left[i].commitEdit();
                        }
                        catch (ParseException pe) {
                        }
                        f = Float.parseFloat(String.valueOf(recorded_exposure_left[i].getValue()));
                        if (calibrate) {
                            rec_exposure_left[i]=f-(effect+adjustment);
                        } else {
                            rec_exposure_left[i]= f;
                        }
                        applet.newdata_row(i,rec_exposure_left[i], rec_exposure_right[i], rec_speed_1st[i], rec_speed_2nd[i]);
                        break;
                } else if (source.equals(recorded_exposure_right[i])){
                        try {
                            recorded_exposure_right[i].commitEdit();
                        }
                        catch (ParseException pe) {
                        }
                        f=Float.parseFloat(String.valueOf(recorded_exposure_right[i].getValue()));
                        if (calibrate) {
                            rec_exposure_right[i]=f-(adjustment-effect);
                        } else {
                            rec_exposure_right[i]=f;
                        }
                        applet.newdata_row(i,rec_exposure_left[i], rec_exposure_right[i], rec_speed_1st[i], rec_speed_2nd[i]);
                        break;
                } else if (source.equals(recorded_speed_1st[i])){
                        try {
                            recorded_speed_1st[i].commitEdit();
                        }
                        catch (ParseException pe) {
                        }
                        f = Float.parseFloat(String.valueOf(recorded_speed_1st[i].getValue()));

                        if (calibrate) {
                            rec_speed_1st[i]=f-effect;
                        } else {
                            rec_speed_1st[i]=f;
                        }
                        applet.newdata_row(i,rec_exposure_left[i], rec_exposure_right[i], rec_speed_1st[i], rec_speed_2nd[i]);
                        break;
                } else if (source.equals(recorded_speed_2nd[i])){
                        try {
                            recorded_speed_2nd[i].commitEdit();
                        }
                        catch (ParseException pe) {
                        }
                        f=Float.parseFloat(String.valueOf(recorded_speed_2nd[i].getValue()));
                        if (calibrate) {
                            rec_speed_2nd[i]=f+effect;
                        } else {
                            rec_speed_2nd[i]=f;
                        }
                        applet.newdata_row(i,rec_exposure_left[i], rec_exposure_right[i], rec_speed_1st[i], rec_speed_2nd[i]);
                        break;
                } 
        
            }		

}


public void newControls() {
	int i;
	String str;

	for (i = 0; i<numberofspeeds; i++) {
                add (speeds[i]);

		add(recorded_exposure_left[i]);
		recorded_exposure_left[i].setVisible(true);
		
		add(recorded_exposure_right[i]);
		recorded_exposure_right[i].setVisible(true);

		add(recorded_speed_1st[i]);
		recorded_speed_1st[i].setVisible(true);

		add(recorded_speed_2nd[i]);
		recorded_speed_2nd[i].setVisible(true);
				
		
	}
         speeds[defaultspeed].setSelected(true);

	validate();
	applet.validate();

}

void default_settings ()
{
	int i;
	
	for (i=0; i<numberofspeeds; i++) {
		rec_speed_1st[i] = 0;
		rec_speed_2nd[i] = 0;
		rec_exposure_left[i] = 0;
		rec_exposure_right[i] = 0;
                newdata_row (i);
	}
	autospeed = true;
	currentspeed = defaultspeed;	
}

int find_closest_speed (float millisec)
{
	int i;
	
	for (i=0; i<numberofspeeds-1; i++) {
		if (((speed_values[i]-speed_values[i+1])/2)+speed_values[i+1] < millisec)
                    break;
        }
        setspeed (i);
	return i;
}


public void setspeed (int speed) {
	currentspeed = speed;
        speeds[speed].setSelected(true);
}

public void autoSpeed (boolean value) {
	autospeed = value;
}

public void newcal(float adjust, float eff) {
        adjustment = adjust;
        effect = eff;
        populate_data ();
}

    
public void calEnable (boolean cal) {
        calibrate = cal;
        populate_data ();
}

}