//  tester
//
//  Copyright (c) 2005 Mike Willegal
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import java.awt.*;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

class StableControls extends ConfigControls implements FocusListener, ActionListener {

final int depth = 4;


float [][]	prev_exposure_left = new float [depth] [numberofspeeds];
float [][]	prev_exposure_right = new float [depth] [numberofspeeds];
float [][]	prev_speed_1st = new float [depth] [numberofspeeds];
float [][]	prev_speed_2nd = new float [depth] [numberofspeeds];



//JLabel off_title, on_title, calibrate_title;

StableControls (tester parent)
{
    super(parent);
     stable_default_settings ();
}


public void newdata (byte error, boolean in_autospeed, float exposure_left, float exposure_right, float speed_1st, float speed_2nd)
{
	int j, speed; 
        float min_exposure_left, max_exposure_left;
        float min_exposure_right, max_exposure_right;
        float min_speed_1st, max_speed_1st;
        float min_speed_2nd, max_speed_2nd;
          
        if (in_autospeed && autospeed)
            speed = find_closest_speed((exposure_left+exposure_right)/2);
        else
            speed = currentspeed;
    
	if (error == 0) {
            for (j = 0; j<depth-1; j++) {
                prev_exposure_left [j][speed] = prev_exposure_left [j+1][speed];
                prev_exposure_right [j][speed] = prev_exposure_right [j+1][speed];
                prev_speed_1st [j][speed] = prev_speed_1st [j+1][speed];
                prev_speed_2nd [j][speed] = prev_speed_2nd [j+1][speed];
            }
            prev_exposure_left [depth-1][speed] = exposure_left;
            prev_exposure_right [depth-1][speed] = exposure_right;
            prev_speed_1st [depth-1][speed] = speed_1st;
            prev_speed_2nd [depth-1][speed] = speed_2nd;
 
            min_exposure_left = 1000000000;
            max_exposure_left = 0;
            min_exposure_right = 1000000000;
            max_exposure_right = 0;
            min_speed_1st = 1000000000;
            max_speed_1st = 0;
            min_speed_2nd = 1000000000;
            max_speed_2nd = 0;
            
            rec_exposure_left [speed] = 0;
            rec_exposure_right [speed] = 0;
            rec_speed_1st [speed] = 0;
            rec_speed_2nd [speed] = 0;
            
            for (j = 0; j<depth; j++) {
                    if (prev_exposure_left [j][speed] != 0) {
                        max_exposure_left =  Math.max (prev_exposure_left [j][speed], max_exposure_left);
                        min_exposure_left =  Math.min (prev_exposure_left [j][speed], min_exposure_left);
                   }
                    if (prev_exposure_right [j][speed] != 0) {
                        max_exposure_right =  Math.max (prev_exposure_right [j][speed], max_exposure_right);
                        min_exposure_right =  Math.min (prev_exposure_right [j][speed], min_exposure_right);
                    }
                    if (prev_speed_1st [j][speed] != 0) {
                        max_speed_1st =  Math.max (prev_speed_1st [j][speed], max_speed_1st);
                        min_speed_1st =  Math.min (prev_speed_1st [j][speed], min_speed_1st);
                    }
                    if (prev_speed_2nd [j][speed] != 0) {
                        max_speed_2nd =  Math.max (prev_speed_2nd [j][speed], max_speed_2nd);
                        min_speed_2nd =  Math.min (prev_speed_2nd [j][speed], min_speed_2nd);
                    }
                }
                rec_exposure_left[speed] = max_exposure_left - min_exposure_left;
                rec_exposure_right [speed] = max_exposure_right - min_exposure_right;
                rec_speed_1st [speed] = max_speed_1st - min_speed_1st;
                rec_speed_2nd [speed] = max_speed_2nd - min_speed_2nd;
    
            newdata_row(speed);
   	}  
    
    }
    
    void stable_default_settings ()
    {
    int i,j;
    for (i = 0; i < numberofspeeds; i++) {
        for (j = 0; j<depth; j++) {
            prev_exposure_left [j][i] = 0;
            prev_exposure_right [j][i] = 0;
            prev_speed_1st [j][i] = 0;
            prev_speed_2nd [j][i] = 0;
        }
    }
}

  
}


